;	THIS ROUTINE DRAWS EITHER THE GRATICLE OR A BOX IN THE 
;	VIDEO MEMORY.  IT LOOKS LIKE:
;
;		CALL GRAT!(GRATON)
;
;			IF GRATON=0 THEN A BOX IS DRAWN, ELSE DRAW 
;			THE ENTIRE GRATICLE IS DRAWN
;
;
;
PAGE,132
GRAT      SEGMENT
          ASSUME    CS:GRAT   
START	  PROC	    FAR	 
ODD	EQU	2000H			;ODD ROW OFFSET
	  PUSH	    BP		;SAVE BP
	  MOV	    BP,SP		;GET STACK POINTER
	INC	BP
	INC	BP
	  MOV	    SI,4[BP]		;GET ARGUMENT ADDRESS FROM STACK
	  MOV	    DX,WORD PTR [SI]	;GET ARGUMENT FROM CALLING ROUTINE
		MOV	DI,00H		;START ADDRESS
;  ERASE VIDEO MEMORY
	CLD				;COUNT UP
	PUSH	DS			;STORE DATA SEMENT			
	PUSH	ES			;STORE EXTRA SEGMENT
	MOV	AX,0B800H		;MOV VIDEO ADDRESS TO ES AND DS
	MOV	DS,AX
	MOV	ES,AX
	MOV	AX,00H		;BLANK OUTPUT
	MOV	BX,81D		;79 ROWS
NEXTR:	MOV	CX,63D	;LOOP COUNTER
REP	STOS	BYTE PTR [DI]	;EVEN ROWS
	ADD	DI,17D		;NEXT ROW
	DEC	BX			;DONE?
	JNZ	NEXTR
	MOV	DI,ODD		;NOW DO ODD ROWS
	MOV	BX,80D
NEXTODD:
	MOV	CX,63D
REP	STOS	BYTE PTR [DI]
	ADD	DI,17D
	DEC	BX
	JNZ	NEXTODD
	POP	ES			;RESTORE ES
;
;  IF DX<>0 THEN WILL WRITE GRAT, IF DX=0 THEN WILL ERASE GRAT
;
	CMP	DX,00
	JNE	ALL
	JMP	BOX
;
;  NOW DO  VERTICLE LINES
;
ALL:	MOV	BL,39		;DO IT 39 TIMES
         MOV        SI,0A6H        ;TOP OF FIRST VERTICLE LINE
         MOV        DX,0A0H        ;EVERY OTHER ROW ADDRESS
         MOV        AH,20H         ;OUTPUT BYTE
         CALL       GRATOUT
;
         MOV        SI,0D8H        ;TOP OF 9TH LINE
         CALL       GRATOUT
;
         MOV        SI,0ACH        ;TOP OF 2ND LINE
         MOV        AH,08H         ;OUTPUT BYTE
         CALL       GRATOUT
;
         MOV        SI,0C5H        ;TOP OF 6TH LINE
         CALL       GRATOUT
;
         MOV        SI,0B2H        ;TOP OF 3RD LINE
         MOV        AH,02H         ;OUTPUT BYTE
         CALL       GRATOUT
;
         MOV        SI,0CBH        ;TOP OF 7TH LINE
         CALL       GRATOUT
;
         MOV        SI,0B9H        ;TOP OF 4TH LINE
         MOV        AH,80H         ;OUTPUT BYTE
         CALL       GRATOUT
;
         MOV        SI,0D2H        ;TOP OF 8TH LINE
         CALL       GRATOUT
;
         MOV        SI,0BFH        ;TOP OF CENTER LINE
         MOV        AH,0A8H        ;HASH MARKS
         CALL       GRATOUT
;
;
;    NOW DRAW H. LINES AND H. HASH MARKS
;
;
;    FIRST,OUTPUT ALL THE '80H'
;
         MOV        AH,80H
         MOV        DX,05          ;EVERY 5TH BYTE
         MOV        BL,13          ;REPEAT 13 TIMES
         MOV        SI,320H
         CALL       GRATOUT
         MOV        SI,640H
         CALL       GRATOUT
         MOV        SI,960H
         CALL       GRATOUT
         MOV        SI,0FA0H
         CALL       GRATOUT
         MOV        SI,12C0H
         CALL       GRATOUT
	MOV	SI,15E0H
	CALL	GRATOUT
	MOV	SI,2C30H
         CALL       GRATOUT
         MOV        SI,2C80H
         CALL       GRATOUT
;
;    ALL THE '20' 
;
         MOV        AH,20H
         MOV        SI,321H
         CALL       GRATOUT
         MOV        SI,641H
         CALL       GRATOUT
         MOV        SI,961H
         CALL       GRATOUT
         MOV        SI,0FA1H
         CALL       GRATOUT
         MOV        SI,12C1H
         CALL       GRATOUT
         MOV        SI,15E1H
         CALL       GRATOUT
         MOV        SI,2C31H
         CALL       GRATOUT
         MOV        SI,2C81H
         CALL       GRATOUT
;
;    ALL THE '08'
;
         MOV        AH,08H
         MOV        SI,322H
         CALL       GRATOUT
         MOV        SI,642H
         CALL       GRATOUT
         MOV        SI,962H
         CALL       GRATOUT
         MOV        SI,0FA2H
         CALL       GRATOUT
         MOV        SI,12C2H
         CALL       GRATOUT
         MOV        SI,15E2H
         CALL       GRATOUT
         MOV        SI,2C32H
         CALL       GRATOUT
         MOV        SI,2C82H
         CALL       GRATOUT
;
; I'M NOT SURE WHAT THIS IS, BUT IT MUST BE IMPORTANT
;
         MOV        BL,12D         ;START DOING EVERYTHING 12 TIMES
         MOV        SI,0C82H
         CALL       GRATOUT
;
;    NOW DO ALL THE '02'
;
	MOV	AH,02H
	MOV	SI,323H
	CALL	GRATOUT
         MOV        SI,643H
         CALL       GRATOUT
         MOV        SI,963H
         CALL       GRATOUT
         MOV        SI,0FA3H
         CALL       GRATOUT
         MOV        SI,12C3H
         CALL       GRATOUT
         MOV        SI,15E3H
         CALL       GRATOUT
         MOV        SI,2C33H
         CALL       GRATOUT
         MOV        SI,2C83H
         CALL       GRATOUT
;
;    NOW DO VERTICLE HASH MARKS
;
         MOV        AH,42H         ;HASH MARK
         MOV        SI,0C83H
         CALL       GRATOUT
         MOV        AH,10H
         MOV        SI,0C84H
         CALL       GRATOUT
;
         MOV        BL,13
         MOV        AH,84H
         MOV        SI,0C80H
         CALL       GRATOUT
         MOV        AH,21H
         MOV        SI,0C81H
         CALL       GRATOUT
;
         MOV        BL,01H
         MOV        SI,0C9FH
         MOV        AH,0A9H
         CALL       GRATOUT
;
;	CENTER VERTICLE LINE
;
		MOV		DX,0A0H
		MOV		BL,40
         MOV        SI,6FH         ;TOP OF CENTER VERTICLE GRAT 
         MOV        AH,20H         ;OUTPUT BYTE
         CALL       GRATOUT
;
	MOV	BL,3		;ERASE 'FUNNY' HASH MARKS
	MOV	DX,06
	MOV	AH,00
	MOV	SI,2C36H
	CALL	GRATOUT
	MOV	SI,2C86H
	CALL	GRATOUT
	MOV	BL,4
	MOV	SI,2C49H
	CALL	GRATOUT
	MOV	SI,2C99H
	CALL	GRATOUT
	MOV	BL,2
	MOV	SI,2C62H
	CALL	GRATOUT
	MOV	SI,2CB2H
	CALL	GRATOUT
;
;    TOP LINE OF BOX
;
BOX:      MOV        AH,0AAH        ;OUTPUT BYTE FOR TOP AND BOTTEM LINES
          MOV        SI,0000H       ;UPPER LEFT CORNER
          MOV        DX,1H          ;CONSECUTIVE OUTPUTS
          MOV        BL,62          ;REPEAT 62 TIMES
          CALL       GRATOUT        ;OUTPUT ROUTINE
;
;    BOTTEM LINE OF BOX
;
          MOV        SI,1900H       ;BOTTEM LEFT CORNER
          CALL       GRATOUT
;
;    FINISH RIGHTMOST EDGE OF TOP AND BOTTEM LINES
;
          MOV        SI,3EH         ;END OF FIRST LINE
          MOV        AH,0A8H        ;END BYTE
          MOV        BL,02H         ;DO TWICE
          MOV        DX,1900H       ;END OF LAST LINE IS 193EH
          CALL       GRATOUT
;
;		LEFTAND RIGHT VERTICAL LINES 
;
         MOV        SI,50H         ;LEFTMOST BYTE OF FIRST EVEN ROW
         MOV        AH,80H         ;OUTPUT BYTE
         MOV        DX,50H         ;INCREMENT BY ROWS
         MOV        BL,79          ;DO IT 79 TIMES
         CALL       GRATOUT
;
         MOV        SI,2000H       ;NOW GO BACK AND GET ODD ROWS
         CALL       GRATOUT 
	MOV	BL,01H		;FINISH LINE
	CALL	GRATOUT
	MOV	BL,79		;RESTORE BL
;
;
         MOV        SI,8EH         ;TOP OF RIGHT VERTICLE LINE
         MOV        AH,08H         ;OUTPUT BYTE
         CALL       GRATOUT
;
         MOV        SI,203EH       ;NOW GET THE ODD ROWS
         CALL       GRATOUT
	MOV	BL,01H		;FINISH LINE
	CALL	GRATOUT
;
	POP	DS
	MOV	BP,SP		;IF GRAT ON, FIX TWO DOTS THAT WERE LEFT OUT BEFORE
	INC	BP
	INC	BP
	MOV	SI,4[BP]
	MOV	DX,[SI]
	CMP	DX,00
	JZ	DONE
	PUSH 	DS
	MOV	AX,0B800H
	MOV	DS,AX
	MOV	AH,21H
	MOV	BX,3231
	MOV	[BX],AH
	MOV	AH,84H
	MOV	BX,3200
	MOV	[BX],AH
;
;
;
	POP	DS				;RESTORE DS
DONE:	POP	BP		
         RET        2
START	ENDP
;
;
;    OUTPUT SUBROUTINE
;
;    AH.....OUTPUT BYTE
;    DX.....INCREMENT BETWEEN OUTPUT ADDRESSES
;    SI.....CONTAINS OUTPUT ADDRESS OF FIRST OUTPUT BYTE
;    BL.....CONTAINS NUMBER OF TIMES PROCEDURE IS TO BE REPEATED
;
;
GRATOUT  PROC
;
         MOV        CL,BL          ;MOVE COUNT TO CX
	MOV	CH,00H
;
OUTLOOP:
	    OR		[SI],AH		;WRITE NEW BYTE
         ADD        SI,DX          ;INCREMENT VIDEO POINTER
         LOOP       OUTLOOP        ;DEC CX AND CONTINUE IF NOT ZERO
         RET
GRATOUT  ENDP
GRAT     ENDS
          END
